using System;
using System.Data;

using DevExpress.XtraEditors;
using DevExpress.XtraGrid.Views.Base;
using DevExpress.XtraGrid.Views.Grid;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public partial class MainForm : XtraForm
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainForm()

        /// <summary>
        /// 
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            Load                                  += Form_Load;
            this.gridView.CustomUnboundColumnData += gridView_CustomUnboundColumnData;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region  ε óϱ - Form_Load(sender, e)

        /// <summary>
        ///  ε óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void Form_Load(object sender, EventArgs e)
        {
            DataTable dataTable = new DataTable();

            dataTable.Columns.Add("ID"         , typeof(int   ));
            dataTable.Columns.Add("Name"       , typeof(string));
            dataTable.Columns.Add("Description", typeof(string));

            for(int i = 1; i < 10; i++)
            {
                dataTable.Rows.Add(i, string.Format("Item{0}", i), DataProvider.DescriptionArray[i % 4]);
            }

            this.gridControl.DataSource = dataTable;
        }

        #endregion
        #region ׸  ٿ ÷  Ŀ ϱ - gridView_CustomUnboundColumnData(sender, e)

        /// <summary>
        /// ׸  ٿ ÷  Ŀ ϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void gridView_CustomUnboundColumnData(object sender, CustomColumnDataEventArgs e)
        {
            GridView gridView = sender as GridView;

            if(e.Column.FieldName == "SimpleText" && e.IsGetData)
            {
                object value = gridView.GetListSourceRowCellValue(e.ListSourceRowIndex, descriptionColumn);

                e.Value = this.descriptionRepositoryItemRichTextEdit.ConvertEditValueToPlainText(value);
            }
        }

        #endregion
    }
}